﻿using System;

namespace DPackLib
{
    public class MockDataMaker
    {
        Random rand = new Random();
        string[] cons = { "b", "c", "d", "f", "g", "h", "j", "k", "l", "m", "n", "p", "q", "r", "s", "t", "v", "w", "x", "y", "z" };
        string[] vowel = { "a", "e", "i", "o", "u" };

        public DataPack CreateMockDataPack(string description)
        {
            return new DataPack
            {
                Data = rand.NextDouble(),
                DateTimeTicks = DateTime.Now.Ticks,
                IsReturned = false,
                PackDescription = description,
                Message = GenerateMockWord(rand.Next(5, 15))
            };
        }

        public double GenerateMockData()
        {
            return rand.NextDouble();
        }

        public string GenerateMockWord(int length)
        {
            if (length < 1) return "Error !";

            string word = string.Empty;

            if (rand.Next() % 2 == 0) // randomly choose a vowel or consonant to start the word
                word += cons[rand.Next(0, 20)];
            else
                word += vowel[rand.Next(0, 4)];

            for (int i = 1; i < length; i += 2) // the counter starts at 1 to account for the initial letter
            { // and increments by two since we append two characters per pass
                var c = cons[rand.Next(0, 20)];
                var v = vowel[rand.Next(0, 4)];

                if (c == "q") // append qu if the random consonant is a q
                    word += "qu";
                else // otherwise just append a random consant and vowel
                    word += c + v;
            }

            // the word may be short a letter because of the way the for loop above is constructed
            if (word.Length < length) // we'll just append a random consonant if that's the case
                word += cons[rand.Next(0, 20)];

            return word;
        }

    }

}
