﻿using Monitor.Interfaces;
using Microsoft.Practices.Unity;
using Prism.Mvvm;

namespace Monitor.ViewModels
{
    public class Anim3DtextViewModel: BindableBase, IAnim3DtextViewModel
    {

        [InjectionMethod]
        public void InitializeAnim3DtextView()
        {
           StartText = startTxt;
        }

        #region Start Text

        private string startTxt =
            " A not so long time ago in a galaxy far, far away....\r\n\r\n " +
            " Specifically made for 'Orbus Software', a demo project was designed to prove my knowledge of contemporary " +
            "common WPF programming methods.\r\n " +
            " The project is created using MVVM pattern, navigation and loading of components is done using PRISM libraries (v6.1)" +           
            " Unity container (v6.1) was used for dependency injection. \r\n " +
            " The project consists of two components: \r\n" +
            "  1. Application 'Generators' to create an unlimited number of different types of signal generators. " +
            "Each generator can automatically generate artificial mock data packs, or you can enter the actual data. " +
            "You can adjust the frequency of each signal generator output. \r\n " +
            "  2. Application 'Monitor' for receiving and displaying data. This unit detects signals from all generators, " +
            "automatically creating indicators for each and displaying the data in real time.\r\n" +
            "It is also possible to send data to the feedback and instruction.\r\n\r\n"+
            " May The Force Be With You. \r\n\r\n" +
            " Alex Novikov";

        #endregion

        #region Binding

        private string _startText;

        public string StartText
        {
            get { return _startText; }
            set { SetProperty(ref _startText, value); }
        }

        #endregion
    }
}
