﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Data.Entity;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;

namespace WcfSignalService
{
    [ServiceContract]
    public interface ISignalService
    {
        [OperationContract]
        bool AddData(DataPack dataPack, int limit);

        [OperationContract]
        string[] GetData(string lineId);

        [OperationContract]
        string[] GetLineData(string lineId);

        [OperationContract]
        string TestConnection();

        [OperationContract]
        void SetDbLimit(string passw,int limit);

        [OperationContract]
        void DropDb(string passw);

        [OperationContract]
        void CleanDb(string passw);
    }

    [DataContract]
    [Serializable]
    public class DataPack
    {
        [Key]
        [DataMember]
        public int PackId { get; set; }

        [DataMember]
        public string Message { get; set; }

        [DataMember]
        public string PackDescription { get; set; }

        [DataMember]
        public bool IsReturned { get; set; }

        [DataMember]
        public double Data { get; set; }

        [DataMember]
        public long DateTimeTicks { get; set; }

        public virtual LineDataSet LineDataSet { get; set; }
    }

    [DataContract]
    [Serializable]
    public class LineDataSet
    {
        [Key]
        [DataMember]
        public int LineId { get; set; }

        [DataMember]
        public string LineDescription { get; set; }

        [DataMember]
        public virtual ICollection<DataPack> DataPacks { get; set; }
    }

    [DataContract]
    public class SignalContext : DbContext
    {
        public SignalContext() : base("SignalContext"){/*Database.SetInitializer(new CreateDatabaseIfNotExists<SignalContext>());*/}

        [DataMember]
        public DbSet<DataPack> DataPacks { get; set; }

        [DataMember]
        public DbSet<LineDataSet> LineDataSets { get; set; }
    }

}
